#include "table_comm.h"

#define SOC_OCV_SOC_LEN		11
#define SOC_OCV_TEMP_LEN	7

int8_t x_soc_tab[SOC_OCV_SOC_LEN] = { 100, 90, 80, 70, 60, 50, 40, 30, 20, 10, 0 };
int8_t y_temp_tab[SOC_OCV_TEMP_LEN] = { -20, -10, 0, 10, 25, 40, 55 };

int16_t z_volt_tab[SOC_OCV_SOC_LEN * SOC_OCV_TEMP_LEN] =
{
	3414, 3294, 3291, 3287, 3282, 3276, 3269, 3262, 3255, 3250, 3243,
	3388, 3305, 3303, 3298, 3292, 3285, 3277, 3269, 3260, 3252, 3244,
	3366, 3316, 3314, 3307, 3299, 3291, 3283, 3273, 3260, 3241, 3224,
	3377, 3324, 3325, 3319, 3303, 3292, 3286, 3280, 3265, 3228, 3195,
	3386, 3329, 3330, 3329, 3310, 3292, 3291, 3286, 3255, 3208, 2810,
	3420, 3331, 3331, 3331, 3311, 3295, 3294, 3284, 3250, 3207, 2767,
	3399, 3333, 3332, 3332, 3316, 3299, 3298, 3281, 3248, 3206, 2745,
};



ThreeDTabItem ocv_table = 
{
    .x.len = SOC_OCV_SOC_LEN,
	.x.type = kTabDataType_8Bit,
	.x.tab = (uint8_t*)x_soc_tab,

	.y.len = SOC_OCV_TEMP_LEN,
	.y.type = kTabDataType_8Bit,
	.y.tab = (uint8_t*)y_temp_tab,

	.z.len = SOC_OCV_SOC_LEN * SOC_OCV_TEMP_LEN,
	.z.type = kTabDataType_16Bit,
	.z.tab = (uint8_t*)z_volt_tab,
};

/******************************************************时代星云OCV****************************************************************/
#define SOC_OCV_SOC_CNTE_LEN	21
#define SOC_OCV_TEMP_CNTE_LEN	1
int8_t x_soc_cnte_tab[SOC_OCV_SOC_CNTE_LEN] = { 95, 90, 85, 80, 75, 70, 65, 60, 55, 50, 45, 40, 35, 30, 25, 20, 15, 10, 5, 3, 0 };
int8_t y_temp_cnte_tab[SOC_OCV_TEMP_CNTE_LEN] = {25 };

int16_t z_volt_cnte_tab[SOC_OCV_SOC_CNTE_LEN * SOC_OCV_TEMP_CNTE_LEN] =
{
	3333, 3331, 3330, 3329, 3329, 3328, 3328, 3317, 3295, 3291, 3290, 3289, 3288, 3285, 3269, 3252, 3220, 3205, 3151, 3053, 2842,
};
ThreeDTabItem ocv_table_cnte = 
{
    .x.len = SOC_OCV_SOC_CNTE_LEN,
	.x.type = kTabDataType_8Bit,
	.x.tab = (uint8_t*)x_soc_cnte_tab,

	.y.len = SOC_OCV_TEMP_CNTE_LEN,
	.y.type = kTabDataType_8Bit,
	.y.tab = (uint8_t*)y_temp_cnte_tab,

	.z.len = SOC_OCV_SOC_CNTE_LEN * SOC_OCV_TEMP_CNTE_LEN,
	.z.type = kTabDataType_16Bit,
	.z.tab = (uint8_t*)z_volt_cnte_tab,
};


const ThreeDTabItem *ocv_table_list[kOcvTab_End] = {&ocv_table, &ocv_table_cnte};
